## blitz++ 1.0.2+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12) # FindPython
cmake_policy(VERSION 3.1)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

#   Blitz version and release date.

set(blitz_MAJOR 1)
set(blitz_MINOR 0)
set(blitz_PATCH 2)
set(blitz_VERSION ${blitz_MAJOR}.${blitz_MINOR}.${blitz_PATCH})
set(blitz_Release "2017-10-2")
set(BZ_PACKAGE_STRING "${CMAKE_PROJECT_NAME} ${blitz_MAJOR}.${blitz_MINOR}")

#   Set the project

project(blitz VERSION ${blitz_VERSION} LANGUAGES CXX)

option(BUILD_DOC "Build documentation" OFF)
option(BUILD_TESTING "Build tests, examples and benchmarks" OFF)

#   Packaging

set(CPACK_GENERATOR "TGZ")
set(CPACK_PACKAGE_VERSION_MAJOR ${blitz_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${blitz_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${blitz_PATCH})
set(CPACK_SOURCE_GENERATOR "TBZ2")
set(CPACK_SOURCE_PACKAGE_FILE_NAME blitz-${blitz_VERSION})
set(CPACK_SOURCE_IGNORE_FILES ".*.swp$" ".*.swo$" "~$" ".bz2$" ".gz$")

include(CPack)
include(UnitTests)
include(BlitzConfigFileName)
include(Win32Compat)
include(CreatePkgConfig)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

include_directories(BEFORE SYSTEM ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})

add_custom_target(generated-headers ALL)

set(PKGCONFIG_LIBS -lblitz)

add_subdirectory(blitz)
add_subdirectory(random)
add_subdirectory(src)
if (BUILD_DOC)
    add_subdirectory(doc)
endif()

if (BUILD_TESTING)
    add_subdirectory(testsuite)
    add_subdirectory(examples)
    add_subdirectory(benchmarks)
endif()

#   Add a custom target to mimic autotools "make lib"

add_custom_target(lib DEPENDS blitz)

#   Configuration files.

CreatePkgConfigInfo(blitz)

write_basic_package_version_file(
    cmake/${PROJECT_NAME}ConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion)
configure_package_config_file(
    cmake/${PROJECT_NAME}Config.cmake.in
    cmake/${PROJECT_NAME}Config.cmake
    INSTALL_DESTINATION lib/cmake/)

#   Installation

install(EXPORT ${PROJECT_NAME}Targets DESTINATION lib/cmake)
install(FILES
        ${CMAKE_BINARY_DIR}/blitz.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
        DESTINATION lib/cmake/)

=== benchmarks/CMakeLists.txt ===
#set(OTHER_BENCH tinydaxpy hao-he iter)
set(OTHER_BENCH tinydaxpy iter)

option(FORTRAN_BENCHMARKS "Enable Fortran benchmarks" OFF)
if (FORTRAN_BENCHMARKS)
    enable_language(Fortran OPTIONAL)
    set(daxpy_SOURCES daxpy.cpp fdaxpy.f fidaxpy.f)
    set(stencil_SOURCES stencil.cpp stencilf.f stencilf2.f)
    set(acoustic_SOURCES acoustic.cpp acousticf.f acousticf2.f)
    set(acou3d_SOURCES acou3db1.cpp acou3db2.cpp acou3db3.cpp acou3db4.cpp \ acou3d.cpp acou3df.f acou3df2.f )
    set(LOOP_KERNELS loop1 loop2 loop3 loop5 loop6 loop8 loop9 loop10 loop11
        loop12 loop13 loop14 loop15 loop16 loop17 loop18 loop19 loop21 loop22
        loop23 loop24 loop25 loop36 loop100 floop1 floop2 floop3 floop5 floop6 floop8 floop9 floop10 floop11
        floop12 floop13 floop14 floop15 floop16 floop17 floop18 floop19 floop21 floop22
        floop23 floop24 floop25 floop36)
    set(OTHER_BENCH ${OTHER_BENCH} arrdaxpy haney qcd stencil cfd)
    if (CMAKE_Fortran_COMPILER_SUPPORTS_F90)
        set(daxpy_SOURCES ${daxpy_SOURCES} daxpyf90.f90)
        set(stencil_SOURCES ${stencil_SOURCES} stencilf90.f90)
        set(acoustic_SOURCES ${acoustic_SOURCES} acousticf90.f90 acousticf902.f90)
        set(acou3d_SOURCES ${acou3d_SOURCES} acou3df90.f90 acou3df902.f90)
    endif()
endif()

add_custom_target(benchmark)

TESTS(benchmark ${LOOP_KERNELS} ${OTHER_BENCH})

add_custom_target(check-benchmarks
                  DEPENDS blitz benchmark
                  COMMAND ${CMAKE_BUILD_TOOL} test)

set(COMPILE_TIME_BENCHMARKS ctime1 ctime2 ctime3 ctime4 ctime5 ctime1v ctime2v ctime3v ctime4v ctime5v)

=== blitz/CMakeLists.txt ===
include(CheckCXXFeatures)

option(BZ_FULLY64BIT "Enable 64 dimensions with > 2^31 elements (NOT IMPLEMENTED)" OFF)
option(BZ_THREADSAFE "Enable Blitz thread-safety features" OFF)

option(TBB "Use Intel Threading Building Blocks atomic types" OFF)
if (TBB)
    set(BZ_THREADSAFE_USE_TBB TRUE)
    CHECK_HEADER(BZ_HAVE_TBB_ATOMIC_H "tbb/atomic.h")
endif()

option(SIMD_EXTENSION "Facilitate compiler vectorization optimizations for SIMD instruction width of n bytes." OFF)
if (SIMD_EXTENSION)
    set(USE_ALIGNMENT_PRAGMAS TRUE)
    CHECK_ALIGNMENT_DIRECTIVE(BZ_)
    set(BZ_SIMD_WIDTH 1 CACHE STRING "Size of simd types in bytes.")
    if (BZ_SIMD_WIDTH GREATER 1)
        option(ARRAY_LENGTH_PADDING "Sets the default array padding policy to pad all lowest-rank lengths to nearest larger SIMD width. Caution: This means that arrays will in general be non-contiguous." OFF)
        if (ARRAY_LENGTH_PADDING)
            set(BZ_PAD_ARRAYS TRUE)
        endif()
    endif()
else()
    set(BZ_SIMD_WIDTH 1)
endif()

set(EXTRA_LIBS)
option(ENABLE_SERIALISATION "Enable serialization support using Boost::Serialization" OFF)
if (ENABLE_SERIALISATION)
    find_package(Boost COMPONENTS serialization)
    if (Boost_FOUND)
        set(BZ_HAVE_BOOST TRUE)
        include_directories(${Boost_INCLUDE_DIRS})
        if (Boost_SERIALIZATION_FOUND)
            set(DEP_PKGS ${DEP_PKGS} Boost)
            set(BOOST_command "Boost COMPONENTS serialization" PARENT_SCOPE)
            set(BZ_HAVE_BOOST_SERIALIZATION TRUE)
            set(EXTRA_LIBS ${EXTRA_LIBS} ${BOOST_LIBRARIES})
        else()
            message(WARNING "Boost serialization library not found !")
        endif()
    endif()
endif()

find_library(BZ_HAVE_LIBPAPI papi)
if (BZ_HAVE_LIBPAPI)
    set(DEP_LIBS ${DEP_LIBS} papi)
    set(EXTRA_LIBS ${EXTRA_LIBS} ${BZ_HAVE_LIBPAPI})
    set(PKGCONFIG_LIBS ${PKGCONFIG_LIBS} -lpapi)
endif()

find_library(BZ_HAVE_LIBM m)
if (BZ_HAVE_LIBM)
    set(DEP_LIBS ${DEP_LIBS} m)
    set(EXTRA_LIBS ${EXTRA_LIBS} ${BZ_HAVE_LIBM})
    set(PKGCONFIG_LIBS ${PKGCONFIG_LIBS} -lm)
endif()
set(BLITZ_EXTRA_LIBRARIES ${EXTRA_LIBS} PARENT_SCOPE)
set(DEPS ${DEP_PKGS} LIBRARIES ${DEP_LIBS} PARENT_SCOPE)

if (NOT CHECKED_COMPILER_CXX_FEATURES)
    CHECK_ALL_CXX_FEATURES(BZ_)
    CHECK_HEADER(HAVE_INTTYPES_H inttypes.h)
    set(BZ_MATH_ABSINT_IN_NAMESPACE_STD ${BZ_HAVE_MATH_ABSINT_IN_NAMESPACE_STD})
    set(BZ_MATH_FN_IN_NAMESPACE_STD     ${BZ_HAVE_MATH_FN_IN_NAMESPACE_STD})
    set(BZ_ISNAN_IN_NAMESPACE_STD       ${BZ_HAVE_ISNAN_IN_NAMESPACE_STD})
    set(BZ_HAVE_NCEG_RESTRICT_EGCS      ${BZ_HAVE_RESTRICT_EGCS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.h.in ${BLITZ_CONFIG_FILE})
    set(CHECKED_COMPILER_CXX_FEATURES TRUE CACHE INTERNAL "Gating variable to avoid checking compiler features multiple times")
endif()

macro(GENERATE_BLITZ_HEADER header prog var)
    add_custom_target(${header} ALL)
    add_dependencies(${header} ${prog})
    add_dependencies(generated-headers ${header})
    add_custom_command(
        COMMAND $<TARGET_FILE:${prog}>
        TARGET  ${header}
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/blitz/generate
        OUTPUTS ${header}
    )
    set(${var} ${${var}} ${CMAKE_CURRENT_BINARY_DIR}/${header})
endmacro()

add_subdirectory(generate) 
add_subdirectory(meta) 
add_subdirectory(array)

set(GENERATED_HEADERS)
GENERATE_BLITZ_HEADER(vecbops.cc    genvecbops  GENERATED_HEADERS)
GENERATE_BLITZ_HEADER(vecuops.cc    genvecuops  GENERATED_HEADERS)
GENERATE_BLITZ_HEADER(vecwhere.cc   genvecwhere GENERATED_HEADERS)
GENERATE_BLITZ_HEADER(vecbfn.cc     genvecbfn   GENERATED_HEADERS)
GENERATE_BLITZ_HEADER(matbops.h     genmatbops  GENERATED_HEADERS)
GENERATE_BLITZ_HEADER(matuops.h     genmatuops  GENERATED_HEADERS)
GENERATE_BLITZ_HEADER(mathfunc.h    genmathfunc GENERATED_HEADERS)
GENERATE_BLITZ_HEADER(promote-old.h genpromote  GENERATED_HEADERS)

set(BLITZ_HEADERS
    array-impl.h array.cc array.h bench.cc bench.h benchext.cc benchext.h blitz.h bounds.h bzdebug.h bzconfig.h
    compiler.h constpointerstack.h etbase.h et-forward.h funcs.h globeval.cc indexexpr.h indexmap-forward.h
    levicivita.h limits-hack.h listinit.h memblock.cc memblock.h minmax.h numinquire.h numtrait.h ops.h
    prettyprint.h promote.h range.h range.cc ranks.h reduce.h shapecheck.h simdtypes.h tau.h timer.h tinymat2.h
    tinymat2.cc tinymat2io.cc tinyvec2.cc tinyvec2.h tinyvec2io.cc tm2fastiter.h tmevaluate.h tv2fastiter.h
    tvevaluate.h traversal.cc traversal.h tuning.h tvcross.h tvecglobs.h update.h wrap-climits.h)

foreach (i ${BLITZ_HEADERS})
    set(HEADERS ${HEADERS} ${CMAKE_CURRENT_SOURCE_DIR}/${i})
endforeach()

install(FILES ${HEADERS} ${GENERATED_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/blitz)
install(FILES ${BLITZ_CONFIG_FILE} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${BLITZ_CONFIG_INSTALL_DIR})

=== doc/CMakeLists.txt ===
add_subdirectory(examples)
add_subdirectory(stencils)

add_custom_target(blitz-doc-prep DEPENDS stencils doc-examples)
add_custom_target(blitz-doc)

add_subdirectory(doxygen)

set(STENCILS
    backward11.texi backward12.texi backward21.texi backward22.texi backward31.texi backward32.texi backward41.texi backward42.texi
    central12.texi central14.texi central22.texi central24.texi central32.texi central34.texi central42.texi central44.texi
    forward11.texi forward12.texi forward21.texi forward22.texi forward31.texi forward32.texi forward41.texi forward42.texi
    Laplacian2D4.texi Laplacian2D.texi)

foreach(i ${STENCILS})
    set(TEXINFOS ${TEXINFOS} stencil/${i})
endforeach()

set(EXAMPLES
    cast.texi debug.texi dump.texi fixed-point.texi fixed.texi io.texi outer.texi output.texi range.texi simple.texi slicing.texi
    storage.texi strideslice.texi xor.texi)

set(OUTPUTS
    cast.out debug.out dump.out fixed.out io.out outer.out output.out
    range.out simple.out slicing.out storage.out strideslice.out xor.out)

foreach(i ${EXAMPLES} ${OUTPUTS})
    set(TEXINFOS ${TEXINFOS} examples/${i})
endforeach()

set(TEXINFOS
    about.texi arrays-ctors.texi arrays-debug.texi arrays-expr.texi arrays-globals.texi arrays-indirect.texi arrays-intro.texi
    arrays-io.texi arrays-members.texi arrays-multi.texi arrays-slicing.texi arrays-stencils.texi arrays-storage.texi arrays-types.texi
    arrays-usertype.texi compiling.texi constants.texi download.texi faq.texi help.texi install.texi legal.texi numinquire.texi
    parallel.texi platforms.texi random.texi tau.texi tinymatrix.texi tinyvector.texi tuning.texi copyright.texi)

set(TEXI_SRC ${CMAKE_CURRENT_SOURCE_DIR}/blitz.texi)
set(TEXI_PROG_ARGS -I ${CMAKE_CURRENT_SOURCE_DIR} -I ${CMAKE_CURRENT_BINARY_DIR})

find_program(MAKEINFO makeinfo)
mark_as_advanced(MAKEINFO)
if (MAKEINFO)
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/blitz.info
                       COMMAND ${MAKEINFO} --no-split ${TEXI_PROG_ARGS} ${TEXI_SRC}
                       DEPENDS blitz-doc-prep ${TEXI_SRC})
    add_custom_target(info DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/blitz.info)
    add_dependencies(blitz-doc info)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/blitz.info DESTINATION ${CMAKE_INSTALL_INFODIR})
endif()

find_program(TEXI2HTML texi2html
             ${CYGWIN_INSTALL_PATH}/bin /bin /usr/bin /usr/local/bin /sbin)
mark_as_advanced(TEXI2HTML)

if (TEXI2HTML)
    set(HTML_DIR ${CMAKE_CURRENT_BINARY_DIR}/html)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html)
    add_custom_target(html ${TEXI2HTML} ${TEXI_PROG_ARGS} --split=chapter ${TEXI_SRC}
                      WORKING_DIRECTORY ${HTML_DIR}
                      DEPENDS blitz-doc-prep
                      SOURCES ${TEXI_SRC})
    add_dependencies(blitz-doc html)
    install(DIRECTORY ${HTML_DIR} DESTINATION ${CMAKE_INSTALL_DOCDIR})
endif()

find_program(TEXI2PDF texi2pdf
             ${CYGWIN_INSTALL_PATH}/bin /bin /usr/bin /usr/local/bin /sbin)
mark_as_advanced(TEXI2PDF)
find_program(PDFLATEX pdflatex
             ${CYGWIN_INSTALL_PATH}/bin /bin /usr/bin /usr/local/bin /sbin)

if (TEXI2PDF AND PDFLATEX)
    find_path(TEXINFO_TEX_DIR "texinfo.tex" HINTS "/usr/share/texmf/tex/texinfo/")
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/blitz.pdf
                       COMMAND TEXINPUTS=:${TEXINFO_TEX_DIR}:; ${TEXI2PDF} ${TEXI_PROG_ARGS} ${TEXI_SRC}
                       DEPENDS blitz-doc-prep ${TEXI_SRC})
    add_custom_target(pdf DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/blitz.pdf)
    add_dependencies(blitz-doc pdf)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/blitz.pdf DESTINATION ${CMAKE_INSTALL_DOCDIR})
endif()

set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
    "blitz.html;blitz.pdf;blitz.aux;blitz.cp;blitz.cps;blitz.fn;blitz.fns;blitz.ky;blitz.log;blitz.pg;blitz.toc;blitz.tp;blitz.vr")

foreach(i AUTHORS COPYING COPYING.LESSER COPYRIGHT LEGAL LICENSE NEWS README.md)
    set(BLITZ_INFORMATION ${BLITZ_INFORMATION} ${CMAKE_SOURCE_DIR}/${i})
endforeach()

# Install files

install(FILES ${BLITZ_INFORMATION} DESTINATION ${CMAKE_INSTALL_DOCDIR})

=== examples/CMakeLists.txt ===
# Old examples that have been removed... Add then again ?
#      cfd curldiv diff erf indirect pauli pick profile qcd rangexpr stencil3 stencil stencilet tiny2 tiny3 transform)

add_custom_target(examples)

set(ALL_EXAMPLES
      array cartesian cast complex-test convolve deriv fixed
      io iter matmult nested numinquire outer polymorph prettyprint
      rand2 random reduce simple slicing stencil2 
      storage tiny useret where whitt)

TESTS(examples ${ALL_EXAMPLES})

add_custom_target(check-examples
                  DEPENDS blitz examples
                  COMMAND ${CMAKE_BUILD_TOOL} test)

set(EXAMPLES)
foreach (example ${ALL_EXAMPLES})
    list(APPEND EXAMPLES ${example}.cpp)
endforeach()

install(FILES ${EXAMPLES} DESTINATION ${CMAKE_INSTALL_DOCDIR}/examples)

=== random/CMakeLists.txt ===
SET(RAMDOM_FILES
    F.h beta.h chisquare.h default.h discrete-uniform.h exponential.h
    gamma.h mt.h mtparam.cc normal.h uniform.h)

INSTALL(FILES ${RAMDOM_FILES} DESTINATION include/random )

=== src/CMakeLists.txt ===
set(blitz_LIB_SRCS globals.cpp)

add_library(blitz SHARED ${blitz_LIB_SRCS})
add_dependencies(blitz generated-headers)

set_target_properties(blitz PROPERTIES
                      VERSION ${blitz_VERSION}
                      SOVERSION 0
                      CLEAN_DIRECT_OUTPUT 1)

set(BLITZ_LIBS blitz)
if (NOT WIN32)
    add_library(blitz-static STATIC ${blitz_LIB_SRCS})
    add_dependencies(blitz-static generated-headers)
    set(BLITZ_LIBS ${BLITZ_LIBS} blitz-static)
    set_target_properties(blitz-static PROPERTIES
                          OUTPUT_NAME blitz
                          ${BLITZ-STATIC-DEFS}
                          CLEAN_DIRECT_OUTPUT 1)
endif()

install(TARGETS ${BLITZ_LIBS}
        EXPORT  ${PROJECT_NAME}Targets
        #RUNTIME DESTINATION bin COMPONENT runtime
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT devel
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT devel
)

=== testsuite/CMakeLists.txt ===
add_definitions(-DBZ_DEBUG)

add_custom_target(testsuite)

UNITTEST(testsuite module module1.cpp module2.cpp)

TESTS(testsuite
      Adnene-Ben-Abdallah-1 Adnene-Ben-Abdallah-2 arrayresize chris-jeffery-1 chris-jeffery-2
      chris-jeffery-3 complex-test constarray contiguous copy ctors derrick-bass-1 derrick-bass-3
      exprctor extract free gary-huber-1 initialize interlace iter Josef-Wagenhuber loop1
      matthias-troyer-1 matthias-troyer-2 mattias-lindstroem-1 minmax minsumpow newet
      Olaf-Ronneberger-1 patrik-jonsson-1 peter-bienstman-1 peter-bienstman-2 peter-bienstman-3
      peter-bienstman-4 peter-bienstman-5 peter-nordlund-1  peter-nordlund-2 peter-nordlund-3
      promote qcd reduce reindex reverse shapecheck shape storage stub theodore-papadopoulo-1
      tinymat tinyvec transpose troyer-genilloud Ulisses-Mello-1 wei-ku-1 where zeek-1)

add_custom_target(check-testsuite
                  DEPENDS blitz testsuite
                  COMMAND ${CMAKE_BUILD_TOOL} test)

=== blitz/array/CMakeLists.txt ===
set(BLITZ_ARRAY_HEADERS
    asexpr.h asexpr.cc cartesian.h cgsolve.h complex.cc convolve.cc convolve.h cycle.cc domain.h et.h expr.h expr.cc
    fastiter.h funcs.h functorExpr.h geometry.h indirect.h interlace.cc io.cc iter.h map.h methods.cc misc.cc multi.h
    newet-macros.h newet.h ops.cc ops.h reduce.cc reduce.h resize.cc shape.h slice.h slicing.cc stencil-et.h
    stencil-et-macros.h stencilops.h stencils.cc stencils.h storage.h where.h zip.h)

foreach(i ${BLITZ_ARRAY_HEADERS})
    set(HEADERS ${HEADERS} ${CMAKE_CURRENT_SOURCE_DIR}/${i})
endforeach()

GENERATE_BLITZ_HEADER(bops.cc genarrbops BLITZ_ARRAY_GENERATED_HEADERS)
GENERATE_BLITZ_HEADER(uops.cc genarruops BLITZ_ARRAY_GENERATED_HEADERS)

find_package (Python COMPONENTS Interpreter)

add_custom_target(stencil-classes.cc ALL
                  COMMAND ${Python_EXECUTABLE}  ${CMAKE_CURRENT_SOURCE_DIR}/../generate/genstencils.py stencil-classes.cc
                  MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/../generate/genstencils.py)
add_dependencies(generated-headers stencil-classes.cc)

set(BLITZ_ARRAY_GENERATED_HEADERS ${BLITZ_ARRAY_GENERATED_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/stencil-classes.cc)

install(FILES ${HEADERS} ${BLITZ_ARRAY_GENERATED_HEADERS} DESTINATION include/blitz/array)

=== blitz/generate/CMakeLists.txt ===
add_executable(genarrbops  genarrbops.cpp)
add_executable(genarruops  genarruops.cpp)
add_executable(genmatbops  genmatbops.cpp)
add_executable(genmatuops  genmatuops.cpp)
add_executable(genvecbops  genvecbops.cpp)
add_executable(genvecuops  genvecuops.cpp)
add_executable(genvecwhere genvecwhere.cpp)
add_executable(genvecbfn   genvecbfn.cpp)
add_executable(genmathfunc genmathfunc.cpp)
add_executable(genpromote  genpromote.cpp)

=== blitz/meta/CMakeLists.txt ===
set(BLITZ_META_HEADERS dot.h matassign.h matmat.h matvec.h metaprog.h product.h sum.h vecassign.h)

install(FILES ${BLITZ_META_HEADERS} DESTINATION include/blitz/meta)

=== doc/doxygen/CMakeLists.txt ===
# Configure the script and the Doxyfile, then add target

find_package(Doxygen)

if (DOXYGEN_FOUND)
    if (NOT DOXYGEN_DOT_PATH)
        get_filename_component(DOT_PATH ${DOT} PATH)
    endif()

    option(DISABLE_REFMAN_PDF "Disable generation of refman.pdf" OFF)

    set(top_srcdir ${CMAKE_SOURCE_DIR})
    set(top_builddir ${CMAKE_BINARY_DIR})
    set(enable_latex_docs YES)
    set(enable_html_docs YES)
    set(enable_dot YES)
    set(PACKAGE_NAME ${CMAKE_PROJECT_NAME})
    set(PACKAGE_VERSION ${blitz_VERSION})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)

    add_custom_target(doxygen ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
                      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/ DESTINATION ${CMAKE_INSTALL_DOCDIR}/reference)
    add_dependencies(blitz-doc doxygen)

    if (NOT DISABLE_REFMAN_PDF)
        add_custom_command(OUTPUT latex/refman.pdf
                           COMMAND make
                           WORKING_DIRECTORY latex
                           DEPENDS doxygen)

        add_custom_target(doxygen-latex DEPENDS latex/refman.pdf)
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/latex/refman.pdf DESTINATION ${CMAKE_INSTALL_DOCDIR})
        add_dependencies(blitz-doc doxygen-latex)
    endif()

    set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "html;latex;doxygen-warning")
endif()

=== debian/changelog ===
blitz++ (1:1.0.2+ds-4.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:22:10 +0000

blitz++ (1:1.0.2+ds-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061932

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 03:21:46 +0000

blitz++ (1:1.0.2+ds-4) unstable; urgency=medium

  * Debianization:
    - d/watch, update for GitHub URL changes;
    - d/s/lintian-overrides, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 20 Nov 2022 16:05:45 +0000

blitz++ (1:1.0.2+ds-3) unstable; urgency=medium

  [ Jerome Benoit ]
  * Debianization:
    - Maintenance, migrate to Debian Math Team;
    - d/patches/*:
      - d/p/debianization.patch, merge patches by Vagrant Cascadian;
      - d/p/debianization*.patch, set Forwarded to not-needed;
    - d/rules:
      - dpkg material, include now;
      - harden;
    - d/copyright:
      - copyright year tuple, update;
    - d/upstream/metadata, introduce;
    - d/adhoc/*/Makefile:
      - copyright year tuple, update.

  [ Philip Rinn ]
  * Team work
  * debian/control:
    - debhelper, bump to 13
    - Standards Version, bump to 4.6.1 (no change)
    - Mark libblitz0v5 and libblitz0-dev as 'Multi-Arch: same'
    - Mark libblitz-doc as 'Multi-Arch: foreign'
    - Add 'Rules-Requires-Root: no'
  * Remove unused debian/source/include-binaries
  * Make bzconfig.h reproducible:
    - Remove -{file|debug}-prefix-map from BZ__compiler_options
    - Add patch to use SOURCE_DATE_EPOCH in BZ__config_date (Closes: #977001)
      - Thanks Vagrant Cascadian for the patch
    - Add patch to use DEB_HOST_MULTIARCH as BZ__os_name (Closes: #977003)
      - Thanks Vagrant Cascadian for the patch

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 30 Jul 2022 17:23:40 +0000

blitz++ (1:1.0.2+ds-2) unstable; urgency=medium

  * Debianization:
    - debian/patches/*:
      - d/p/upstream-skip-testsuite.patch, reintroduce.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 02 Nov 2019 12:55:55 +0000

blitz++ (1:1.0.2+ds-1) unstable; urgency=medium

  * New upstream version.
  * Debianization:
    - debian/control:
      - libblitz0-dev package:
        - Suggests field, improve;
      - libblitz-doc package:
        - Suggests field, introduce;
    - debian/copyright:
      - Files-Excluded list, refresh;
    - debian/patches/*:
      - d/p/upstream-*.patch, integrated;
      - d/p/upstream-autotoolization-headers.patch, introduce;
      - d/p/debianization-python.patch, refresh;
      - d/p/debianization-examples.patch, improve;
    - debain/libblitz0{v5,-dev}.docs, update;
    - debian/adhoc/{examples,testsuite}/Makefile:
      - copyright year tuple, update;
    - debian/tests/*, introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 02 Nov 2019 10:15:34 +0000

blitz++ (1:1.0.1+ds-6) unstable; urgency=medium

  * RC fix release (Closes: #941510), build-dependency update.
  * Debianization:
    - debian/control:
      - Standards Version, bump to 4.4.1 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 04 Oct 2019 17:41:43 +0000

blitz++ (1:1.0.1+ds-5) unstable; urgency=medium

  * FTBFS fix release, harden Python 3 migration in d/p/d-python.patch.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 31 Aug 2019 09:46:23 +0000

blitz++ (1:1.0.1+ds-4) unstable; urgency=medium

  * Debianization:
    - debian/copyright:
      - Copyright year tuple, update;
    - debian/control:
      - debhelper, bump to 12;
      - Standards Version, bump to 4.4.0 (no change);
      - Build-Depends field, migrate to Python 3 (Closes: #936218);
    - debian/patches/*:
      - d/p/debianization-python.patch, introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 31 Aug 2019 07:32:31 +0000

=== debian/control ===
Source: blitz++
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>,
           Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>
Section: devel
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 autoconf-archive, automake, libtool, python3,
 gfortran | fortran-compiler, cfortran,
 libblas-dev | libatlas-base-dev,
 liblapack-dev | libatlas-base-dev
Build-Depends-Indep:
 texinfo, texlive-plain-generic, texlive-latex-base
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/blitzpp/blitz
Vcs-Git: https://salsa.debian.org/math-team/blitzxx.git
Vcs-Browser: https://salsa.debian.org/math-team/blitzxx

Package: libblitz0t64
Breaks: libblitz0v5 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libblitz-doc
Conflicts: libblitz0, libblitz0ldbl
X-Time64-Compat: libblitz0v5
Provides: ${t64:Provides}, libblitz0
Replaces: libblitz0v5, libblitz0, libblitz0ldbl
Multi-Arch: same
Description: C++ template class library for scientific computing
 Blitz++ offers a high level of abstraction,
 but performance which rivals Fortran.  The
 current version supports arrays and vectors.
 .
 This package contains the dynamic library.

Package: libblitz0-dev
Architecture: any
Section: libdevel
Depends: libblitz0t64 (= ${binary:Version}), ${misc:Depends}
Suggests: pkg-config, libblitz-doc (= ${source:Version})
Conflicts: libblitz-dev, blitz++
Provides: libblitz-dev, blitz++
Multi-Arch: same
Description: C++ template class library for scientific computing - libdev
 Blitz++ offers a high level of abstraction,
 but performance which rivals Fortran.  The
 current version supports arrays and vectors.
 .
 This package contains the static library
 and header files for  compiling programs with
 blitz++.

Package: libblitz-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: pdf-viewer
Enhances: libblitz0-dev (= ${binary:Version})
Breaks: libblitz0ldbl (<< 1:0.10-2)
Replaces: libblitz0ldbl (<< 1:0.10-2)
Multi-Arch: foreign
Description: C++ template class library for scientific computing - doc
 Blitz++ offers a high level of abstraction,
 but performance which rivals Fortran.  The
 current version supports arrays and vectors.
 .
 This package contains the documentation and examples.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export F77 = gfortran

CPPFLAGS += -DBZ_HAVE_STD

BUILDDIR=_BUILD

default:
	@uscan --no-conf --dehs --report || true

%:
	dh $@ -with autoreconf --builddirectory=$(BUILDDIR) --no-parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-maintainer-mode \
		--enable-static \
		--enable-shared \
		--enable-debug \
		--enable-64bit \
		--disable-doxygen

override_dh_auto_build-arch:
	$(MAKE) -C $(BUILDDIR) lib
	# Make build reproducible
	sed -i \
			-e 's@ [^ ]*-f\(file\|debug\)-prefix-map=[^ ]*@@g' \
			$(BUILDDIR)/blitz/gnu/bzconfig.h

override_dh_auto_build-indep:
	$(MAKE) -C $(BUILDDIR) lib
	$(MAKE) -C $(BUILDDIR) info pdf html

override_dh_auto_test-arch:
	$(MAKE) -C $(BUILDDIR)/examples check
	$(MAKE) -C $(BUILDDIR)/testsuite check
	#$(MAKE) -C $(BUILDDIR)/benchmarks check

override_dh_auto_test-indep:
	@true

override_dh_prep-arch:
	sed -i \
			-e '/^# generated by configure/d' \
			-e 's/ -D_FORTIFY_SOURCE=2//;s/ -Wdate-time//;s/: $$/:/;' \
		$(BUILDDIR)/blitz.pc

## https://bugs.debian.org/726566
override_dh_prep-indep:
	sed -i \
			-e 's/^* Blitz++: (blitz++)/* Blitz++: (blitz)/;' \
		doc/blitz.info

DEB_AUTO_INSTALL_MAKEFLAGS = DESTDIR=$(CURDIR)/debian/tmp
override_dh_auto_install-indep:
	$(MAKE) -C $(BUILDDIR) install-info install-pdf install-html $(DEB_AUTO_INSTALL_MAKEFLAGS)
	$(MAKE) -C $(BUILDDIR)/examples install-examples $(DEB_AUTO_INSTALL_MAKEFLAGS)
	$(MAKE) -C $(BUILDDIR)/testsuite install-testsuite $(DEB_AUTO_INSTALL_MAKEFLAGS)

override_dh_compress-indep:
	dh_compress -Xexamples -Xtestsuite -Xbenchmarks -X.pdf

=== debian/watch ===
version=4
opts=\
repack,compression=xz,repacksuffix=+ds,\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/-/./g,\
filenamemangle=s/(?:.*\/)?(?:rel|v|blitz)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/blitz-$1.$2/ \
https://github.com/blitzpp/blitz/tags \
(?:.*?/archive/(?:.*?/)?)?(?:rel|v|blitz)?[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## blitz++ 20001213

=== benchmarks/Makefile ===
# Generated automatically from Makefile.in by configure.
##############################################################################
#
# Blitz++ benchmarks makefile
#

srcdir = .

BZDIR = $(srcdir)/..

CXX = g++
CXXFLAGS = -ftemplate-depth-30 -O2 -funroll-loops -fstrict-aliasing -fno-gcse -DBZ_FORTRAN_SYMBOLS_WITH_DOUBLE_TRAILING_UNDERSCORES -I$(BZDIR)
F77 = f77
F77FLAGS = -O3
F90 = f90
F90FLAGS = -O3
LDFLAGS = 

LIBS = -L$(BZDIR)/lib -lblitz -lm  -lg2c 

.SUFFIXES: .o .cpp .f

.cpp.o:
	$(CXX) $(CXXFLAGS) -c $*.cpp

.f.o:
	$(F77) $(F77FLAGS) -c $*.f

############################################################################

LOOP_KERNELS = loop1 loop2 loop3 loop5 loop6 loop8 loop9 \
        loop10 loop11 loop12 loop13 loop14 loop15 loop16 loop17 loop18 \
	loop19 loop21 loop22 loop23 loop24 loop25 loop36

BENCHMARKS = daxpy haney qcd stencil tinydaxpy acoustic acou3d hao-he \
	$(LOOP_KERNELS)

COMPILE_TIME_BENCHMARKS = ctime1 ctime2 ctime3 ctime4 ctime5 ctime1v \
	ctime2v ctime3v ctime4v ctime5v

all:	$(BENCHMARKS) 

run:	all
	@for benchmark in $(BENCHMARKS) ; do \
	  ./$$benchmark; \
	done

run-loops:	$(LOOP_KERNELS)
	@for benchmark in $(LOOP_KERNELS) ; do \
	  ./$$benchmark; \
	done

ctime:
	rm -f $(COMPILE_TIME_BENCHMARKS)
	@echo Flags: $(CXXFLAGS)
	@for benchmark in $(COMPILE_TIME_BENCHMARKS) ; do \
	  echo Compile time for $$benchmark.cpp: ; \
	  time $(CXX) $(CXXFLAGS) -c $$benchmark.cpp; \
	done

############################################################################

looptest:	looptest.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o looptest looptest.o $(LIBS)

chunky:	chunky.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o chunky chunky.o $(LIBS)

haney:  haney.o haneyf.o
	${CXX} $(CXXFLAGS) $(LDFLAGS) -o haney haney.o haneyf.o $(LIBS)

daxpyf90.o:	daxpyf90.f
	$(F90) $(F90FLAGS) -c daxpyf90.f

daxpy:	daxpy.o fdaxpy.o fidaxpy.o daxpyf90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o daxpy daxpy.o fdaxpy.o \
           fidaxpy.o daxpyf90.o $(LIBS)

qcd:	qcd.o qcdf.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o qcd qcd.o qcdf.o $(LIBS)

STENCIL_OBJS = stencil.o stencilf.o stencilf2.o stencilf90.o

stencilf90.o:	stencilf90.f
	$(F90) $(F90FLAGS) -c stencilf90.f

stencil:	$(STENCIL_OBJS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o stencil $(STENCIL_OBJS) $(LIBS)

ACOUSTIC_OBJS = acoustic.o acousticf.o acousticf2.o acousticf90.o acousticf902.o

acousticf90.o:	acousticf90.f
	$(F90) $(F90FLAGS) -c acousticf90.f

acousticf902.o:	acousticf902.f
	$(F90) $(F90FLAGS) -c acousticf902.f

acoustic:	$(ACOUSTIC_OBJS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o acoustic $(ACOUSTIC_OBJS) $(LIBS)

ACOU3D_OBJS = acou3db1.o acou3db2.o acou3db3.o acou3db4.o acou3d.o acou3df90.o \
	acou3df.o acou3df2.o acou3df902.o

acou3df90.o:	acou3df90.f
	$(F90) $(F90FLAGS) -c acou3df90.f

acou3df902.o:	acou3df902.f
	$(F90) $(F90FLAGS) -c acou3df902.f

acou3d:	$(ACOU3D_OBJS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o acou3d $(ACOU3D_OBJS) $(LIBS)

tinydaxpy:	tinydaxpy.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o tinydaxpy tinydaxpy.o $(LIBS)

hao-he:	hao-he.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o hao-he hao-he.o $(LIBS)

stenciln:	stenciln.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o stenciln stenciln.o $(LIBS)

############################################################################
# Loop kernel tests
#
# Note: The loop numbers skip around because they represent
# selected loops from a suite used by IBM researchers to test
# the RS/6000.  Missing loops are ones which were too complicated
# to generate automatically.
#
# This section generated by makeloops.cpp

loop1f90.o:	loop1f90.f
	$(F90) $(F90FLAGS) -c loop1f90.f

loop1:	loop1.o loop1f.o loop1f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop1 loop1.o loop1f.o loop1f90.o $(LIBS)

loop2f90.o:	loop2f90.f
	$(F90) $(F90FLAGS) -c loop2f90.f

loop2:	loop2.o loop2f.o loop2f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop2 loop2.o loop2f.o loop2f90.o $(LIBS)

loop3f90.o:	loop3f90.f
	$(F90) $(F90FLAGS) -c loop3f90.f

loop3:	loop3.o loop3f.o loop3f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop3 loop3.o loop3f.o loop3f90.o $(LIBS)

loop5f90.o:	loop5f90.f
	$(F90) $(F90FLAGS) -c loop5f90.f

loop5:	loop5.o loop5f.o loop5f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop5 loop5.o loop5f.o loop5f90.o $(LIBS)

loop6f90.o:	loop6f90.f
	$(F90) $(F90FLAGS) -c loop6f90.f

loop6:	loop6.o loop6f.o loop6f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop6 loop6.o loop6f.o loop6f90.o $(LIBS)

loop8f90.o:	loop8f90.f
	$(F90) $(F90FLAGS) -c loop8f90.f

loop8:	loop8.o loop8f.o loop8f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop8 loop8.o loop8f.o loop8f90.o $(LIBS)

loop9f90.o:	loop9f90.f
	$(F90) $(F90FLAGS) -c loop9f90.f

loop9:	loop9.o loop9f.o loop9f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop9 loop9.o loop9f.o loop9f90.o $(LIBS)

loop10f90.o:	loop10f90.f
	$(F90) $(F90FLAGS) -c loop10f90.f

loop10:	loop10.o loop10f.o loop10f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop10 loop10.o loop10f.o loop10f90.o $(LIBS)

loop11f90.o:	loop11f90.f
	$(F90) $(F90FLAGS) -c loop11f90.f

loop11:	loop11.o loop11f.o loop11f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop11 loop11.o loop11f.o loop11f90.o $(LIBS)

loop12f90.o:	loop12f90.f
	$(F90) $(F90FLAGS) -c loop12f90.f

loop12:	loop12.o loop12f.o loop12f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop12 loop12.o loop12f.o loop12f90.o $(LIBS)

loop13f90.o:	loop13f90.f
	$(F90) $(F90FLAGS) -c loop13f90.f

loop13:	loop13.o loop13f.o loop13f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop13 loop13.o loop13f.o loop13f90.o $(LIBS)

loop14f90.o:	loop14f90.f
	$(F90) $(F90FLAGS) -c loop14f90.f

loop14:	loop14.o loop14f.o loop14f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop14 loop14.o loop14f.o loop14f90.o $(LIBS)

loop15f90.o:	loop15f90.f
	$(F90) $(F90FLAGS) -c loop15f90.f

loop15:	loop15.o loop15f.o loop15f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop15 loop15.o loop15f.o loop15f90.o $(LIBS)

loop16f90.o:	loop16f90.f
	$(F90) $(F90FLAGS) -c loop16f90.f

loop16:	loop16.o loop16f.o loop16f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop16 loop16.o loop16f.o loop16f90.o $(LIBS)

loop17f90.o:	loop17f90.f
	$(F90) $(F90FLAGS) -c loop17f90.f

loop17:	loop17.o loop17f.o loop17f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop17 loop17.o loop17f.o loop17f90.o $(LIBS)

loop18f90.o:	loop18f90.f
	$(F90) $(F90FLAGS) -c loop18f90.f

loop18:	loop18.o loop18f.o loop18f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop18 loop18.o loop18f.o loop18f90.o $(LIBS)

loop19f90.o:	loop19f90.f
	$(F90) $(F90FLAGS) -c loop19f90.f

loop19:	loop19.o loop19f.o loop19f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop19 loop19.o loop19f.o loop19f90.o $(LIBS)

loop21f90.o:	loop21f90.f
	$(F90) $(F90FLAGS) -c loop21f90.f

loop21:	loop21.o loop21f.o loop21f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop21 loop21.o loop21f.o loop21f90.o $(LIBS)

loop22f90.o:	loop22f90.f
	$(F90) $(F90FLAGS) -c loop22f90.f

loop22:	loop22.o loop22f.o loop22f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop22 loop22.o loop22f.o loop22f90.o $(LIBS)

loop23f90.o:	loop23f90.f
	$(F90) $(F90FLAGS) -c loop23f90.f

loop23:	loop23.o loop23f.o loop23f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop23 loop23.o loop23f.o loop23f90.o $(LIBS)

loop24f90.o:	loop24f90.f
	$(F90) $(F90FLAGS) -c loop24f90.f

loop24:	loop24.o loop24f.o loop24f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop24 loop24.o loop24f.o loop24f90.o $(LIBS)

loop25f90.o:	loop25f90.f
	$(F90) $(F90FLAGS) -c loop25f90.f

loop25:	loop25.o loop25f.o loop25f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop25 loop25.o loop25f.o loop25f90.o $(LIBS)

loop36f90.o:	loop36f90.f
	$(F90) $(F90FLAGS) -c loop36f90.f

loop36:	loop36.o loop36f.o loop36f90.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o loop36 loop36.o loop36f.o loop36f90.o $(LIBS)

###########################################################################

clean:
	rm -f *.o *.ii *.int.c *.s ${BENCHMARKS}
